<template>
  <v-app dark>

    <v-navigation-drawer
      floating
      mini-variant
      app
    >
      <v-toolbar flat>
        <v-list>
          <v-list-tile avatar>
            <v-list-tile-avatar>
              <img src="https://assets.gitlab-static.net/uploads/-/system/group/avatar/7603918/tcyr-us.png">
            </v-list-tile-avatar>
          </v-list-tile>
        </v-list>
      </v-toolbar>

      <v-divider></v-divider>

      <v-list dense>
        <v-list-tile>
          <v-list-tile-action>
            <v-icon>home</v-icon>
          </v-list-tile-action>
          <v-list-tile-content>
            <v-list-tile-title>Home</v-list-tile-title>
          </v-list-tile-content>
        </v-list-tile>
        <v-list-tile @click="openRepo">
          <v-list-tile-action>
            <v-icon>source</v-icon>
          </v-list-tile-action>
          <v-list-tile-content>
            <v-list-tile-title>Repo</v-list-tile-title>
          </v-list-tile-content>
        </v-list-tile>
      </v-list>
    </v-navigation-drawer>

    <v-toolbar app fixed>
      <v-toolbar-title>Friend Codes</v-toolbar-title>
    </v-toolbar>

    <v-content>
      <v-container fluid>
        <v-layout align-center justify-center>
          <v-flex xs10>
            <v-data-table
              :headers="headers"
              :items="codes"
              hide-actions
            >
              <template slot="items" slot-scope="props" @click="copyText">
                <td>{{ props.item.name }}</td>
                <td class="text-xs-right" @click="copyText(props.item.code)">{{ props.item.code }}</td>
              </template>
            </v-data-table>
          </v-flex>
        </v-layout>
      </v-container>
    </v-content>
  </v-app>
</template>


<script lang="ts">
import { mapState } from 'vuex';
import { Component, Vue } from 'vue-property-decorator';

@Component({
  computed: mapState(['codes']),
  data: () => ({
    headers: [
      { text: 'Name', align: 'left', value: 'name' },
      { text: 'Code', align: 'right', value: 'code' },
    ],
  }),
})
export default class App extends Vue {
  public created() {
    this.$store.dispatch('loadCodes');
  }

  public openRepo() {
    window.open('https://gitlab.com/tcyr.us/friends', '_blank');
  }

  public async copyText(text: string) {
    await navigator.clipboard.writeText(text);
  }
}
</script>
